# description: Shows BIOS version

log=/var/log/messages

show_me=0
acuconfig_file=`which ACUConfig 2>/dev/null`
ver=$(dmidecode -t0 | grep -m1 Version | awk '{print $2}')

subver=$(dmidecode -t2 | grep -m1 Version | awk '{$1=""; print $0}')
if echo "$subver" | grep -q "O.E.M."; then                          
	subver="Official AMI Release"
fi

rel=$(dmidecode -t0 | grep -m 1 'Release Date' | awk '{print $3}')

if [ "x$acuconfig_file" != "x" ] ; then
    modprobe mei_me
    mei_mod=$(lsmod | grep mei)
    len=${#mei_mod}
    if [ $len -lt 3 ]; then
        echo "Error: mei module is not loaded. Can not access ME."
        show_me=0
    else
        if [ -e $acuconfig_file ]; then
            show_me=1
        else
            show_me=0
        fi 
    fi
fi

if [ $show_me -eq 1 ]; then
    me_ver=$($acuconfig_file -Verbose -Output Console Status | grep -m1 'version:'| cut -d':' -f 2|cut -d',' -f1)
fi

echo -e "\nBIOS Version:\t\t" "$ver" | tee -a $log
echo -e "BIOS Release Date:\t" "$rel" | tee -a $log
echo -e "BIOS SubVersion:\t" "$subver" | tee -a $log
if [ $show_me -eq 1 ]; then
    echo -e "ME Version:\t\t" "$me_ver" | tee -a $log
fi


