/*
 *
 * Copyright (C) Mellanox Technologies Ltd. 2001-2014.  ALL RIGHTS RESERVED.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 */

#ifndef __GPIO_IFC_H__
#define __GPIO_IFC_H__

enum gpio_reg_type { GPIO_USE_SEL, GPIO_IO_SEL, GPIO_LVL, GPIO_RST };
enum gpio_pin_mode { NATIVE_SIG, GPIO_SIG };
enum gpio_pin_dir  { GPIO_OUT, GPIO_IN };
enum gpio_out	   { GPIO_OUT_0, GPIO_OUT_1, GPIO_OUT_NO_CHG };

struct gpio_pin {
    u8 gpio;
    u8 val;
};

struct gpio_param_type {
    u8                  gpio;
	enum gpio_pin_mode  mode;
	enum gpio_pin_dir   dir;
	enum gpio_out       out_val;
};

extern spinlock_t gpiopch_lock;

void gpio_config_pin(struct gpio_param_type* gpio_param);
int gpio_is_gpio(u8 gpio);
int gpio_is_dir_in(u8 gpio);
int gpio_read_bit(u8 gpio);
void gpio_write_bit(u8 gpio, u8 val);
void gpio_write_vec(struct gpio_pin** gpios, u8 num);

#endif
