/**
 *
 * Copyright (C) 2013-2014, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 */
#ifndef __WATCHDOG_H_
#define __WATCHDOG_H_

#include <mlnx_watchdog.h>

#define MLNX_WDT_VER "0.1"

#define CPLD_WATCHDOG_MINOR 167
#define CPLD_WATCHDOG1_MINOR (CPLD_WATCHDOG_MINOR)
#define CPLD_WATCHDOG2_MINOR (CPLD_WATCHDOG_MINOR + 1)
#define CPLD_WATCHDOG3_MINOR (CPLD_WATCHDOG_MINOR + 2)
#define CPLD_WATCHDOG4_MINOR (CPLD_WATCHDOG_MINOR + 3)

typedef int (*mlnx_watchdog_notify_func)(void *subscriber_data);

int mlnx_watchdog_config(struct mlnx_watchdog_config_ioctl_params *wd_config_params,
			 rw_bus_access_func rw_func);
int mlnx_watchdog_enable_disable(struct mlnx_watchdog_enable_disable_ioctl_params *wd_ed_params);
int mlnx_watchdog_clear(wd_obj_e wd_id, wd_clear_e wd_clr);
int mlnx_watchdog_get_counter(wd_obj_e wd_id, u8 *wd_cntr);
int mlnx_watchdog_modify_timer(wd_obj_e wd_id, u8 new_margin);

extern int mlnx_watchdog_notify_subscribe(mlnx_watchdog_notify_func notifunc, void *subscriber_data);
extern int mlnx_watchdog_notify_unsubscribe(mlnx_watchdog_notify_func notifunc, void *subscriber_data);


#endif /* __WATCHDOG_H__ */
 
