/*
*
* Copyright (C) Mellanox Technologies Ltd. 2001-2013.  ALL RIGHTS RESERVED.
*
* This software product is a proprietary product of Mellanox Technologies Ltd.
* (the "Company") and all right, title, and interest in and to the software product,
* including all associated intellectual property rights, are and shall
* remain exclusively with the Company.
*
* This software product is governed by the End User License Agreement
* provided with the software product.
*
*/

#ifndef __IORW_H__
#define __IORW_H__

#define IO_WRITE       1
#define IO_READ        2
#define IO_DFLT_BASE_ADDR   0x2500   /* LPC_CPLD_BASE_ADRR */
#define LPC_CPLD_IO_LEN     0x100

struct iorw_region {
    unsigned short start;
    unsigned short end;
};

#define DYNAMIC_REGION_FIND 0

#if DYNAMIC_REGION_FIND

#define LPC_IO_REGION_FILE    "/sys/devices/platform/lpci2c/io_regions"

struct iorw_region* lpc_regions;
int lpc_reg_num;

#else

#define LPC_REGION_NUM          2
#define LPC_CPLD_I2C_BASE_ADRR  0x2000
#define LPC_CPLD_BASE_ADRR      0x2500

struct iorw_region lpc_regions[LPC_REGION_NUM] = {
    {
        .start = LPC_CPLD_I2C_BASE_ADRR,
        .end = LPC_CPLD_I2C_BASE_ADRR + LPC_CPLD_IO_LEN
    },
    {
        .start = LPC_CPLD_BASE_ADRR,
        .end = LPC_CPLD_BASE_ADRR + LPC_CPLD_IO_LEN
    }
};

#endif // DYNAMIC_REGION_FIND

#endif
