#define I2C_NAME_SIZE   20 // got from <linux/mod_devicetable.h>
#include <stdint.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <time.h>
#include <stdlib.h>
#include "mlnx_if_us.h"

struct mlnx_i2c_virt_bus_ioctl_params orca_sf_prime_switch = {
	.element_num = 1,
	.parent_bus_num	= 1,
	.upper_switch_id = 0,
	.sw = { { 0x00000070, 0, 8, 0, 0x70, { 2, 3, 4, 5, 6, 7, 8, 9 }, "pca9548", "", 0} },
};

struct mlnx_i2c_switch_ioctl_params orca_sf_prime_switch_delete = {
	.element_num = 1,
	.upper_switch_id = 0,
	.sw = { 0x00000070 },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_prime_switch = {
	.element_num = 1,
	.parent_bus_num	= 1,
	.upper_switch_id = 0,
	.sw = { { 0x00000177, 0, 8, 0, 0x77, { 2, 3, 4, 5, 6, 7, 8, 9 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_1 = {
	.element_num = 1,
	.parent_bus_num	= 2,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000272, 0, 8, 1, 0x72, { 10, 11, 12, 13, 14, 15, 16, 17 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_2 = {
	.element_num = 1,
	.parent_bus_num	= 2,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000273, 0, 8, 1, 0x73, { 18, 19, 20, 21, 22, 23, 24, 25 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_3 = {
	.element_num = 1,
	.parent_bus_num	= 2,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000274, 0, 8, 1, 0x74, { 26, 27, 28, 29, 30, 31, 32, 33 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_4 = {
	.element_num = 1,
	.parent_bus_num	= 2,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000275, 0, 8, 1, 0x75, { 34, 35, 36, 37, 38, 39, 40, 41 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_5 = {
	.element_num = 1,
	.parent_bus_num	= 3,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000372, 0, 8, 1, 0x72, { 42, 43, 44, 45, 46, 47, 48, 49 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_6 = {
	.element_num = 1,
	.parent_bus_num	= 3,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000373, 0, 8, 1, 0x73, { 50, 51, 52, 53, 54, 55, 56, 57 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_7 = {
	.element_num = 1,
	.parent_bus_num	= 3,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000374, 0, 8, 1, 0x74, { 58, 59, 60, 61, 62, 63, 64, 65 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_8 = {
	.element_num = 1,
	.parent_bus_num	= 3,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000375, 0, 8, 1, 0x75, { 66, 67, 68, 69, 70, 71, 72, 73 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_9 = {
	.element_num = 1,
	.parent_bus_num	= 4,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000474, 0, 8, 1, 0x74, { 74, 75, 76, 77, 78, 79, 80, 81 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_10 = {
	.element_num = 1,
	.parent_bus_num	= 4,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000475, 0, 8, 1, 0x75, { 82, 83, 84, 85, 86, 87, 88, 89 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params orca_second_switch_11 = {
	.element_num = 1,
	.parent_bus_num	= 7,
	.upper_switch_id = 0x00000177,
	.sw = { { 0x00000770, 0, 8, 1, 0x70, { 90, 91, 92, 93, 94, 95, 96, 97 }, "pca9548", "", 0} },
};

struct mlnx_i2c_switch_ioctl_params orca_prime_switch_delete = {
	.element_num = 1,
	.upper_switch_id = 0,
	.sw = { 0x00000177 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_1_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000272 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_2_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000273 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_3_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000274 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_4_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000275 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_5_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000372 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_6_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000373 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_7_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000374 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_8_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000375 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_9_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000474 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_10_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000475 },
};

struct mlnx_i2c_switch_ioctl_params orca_second_switch_11_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000177,
	.sw = { 0x00000770 },
};

struct mlnx_i2c_virt_bus_ioctl_params prime_switch = {
	.element_num = 1,
	.parent_bus_num	= 1,
	.upper_switch_id = 0,
	.sw = { { 0x00000170, 0, 8, 0, 0x70, { 2, 3, 4, 5, 6, 7, 8, 9 }, "pca9548", "", 0} },
};

struct mlnx_i2c_virt_bus_ioctl_params second_switch = {
	.element_num = 1,
	.parent_bus_num	= 3,
	.upper_switch_id = 0x00000170,
	.sw = { { 0x00000371, 0, 8, 1, 0x71, { 10, 11, 12, 13, 14, 15, 16, 17 }, "pca9548", "", 0} },
};

struct mlnx_i2c_switch_ioctl_params prime_switch_delete = {
	.element_num = 1,
	.upper_switch_id = 0,
	.sw = { 0x00000170 },
};

struct mlnx_i2c_switch_ioctl_params second_switch_delete = {
	.element_num = 1,
	.upper_switch_id = 0x00000170,
	.sw = { 0x00000371 },
};

struct mlnx_i2c_devices_ioctl_params dev_bus0 = {
                .element_num = 2,
                .parent_bus_num = 0,
                .dev = { { 0x50, "24c32", 0 }, { 0x60, "24c512", 0 } },
};

struct mlnx_i2c_devices_ioctl_params dev_bus1 = {
	.element_num = 3,
	.parent_bus_num = 1,
	.dev = { { 0x20, "qsfp", 0 }, { 0x50, "24c32", 0 }, { 0x51, "24c512", 0 } },
};

struct mlnx_i2c_devices_ioctl_params dev_bus2 = {
	.element_num = 1,
	.parent_bus_num = 2,
	.dev = { { 0x48, "switchx", 0 } },
};

struct mlnx_i2c_devices_ioctl_params dev_bus7 = {
	.element_num = 1,
	.parent_bus_num = 7,
	.dev = { { 0x2f, "dummy", 0 } }, // "adm1029"
};

struct mlnx_i2c_devices_ioctl_params dev_bus8 = {
	.element_num = 1,
	.parent_bus_num = 8,
	.dev = { { 0x51, "spd", 0 } },
};
#define GPIO0_BASE_NR 224
#define GPIO1_BASE_NR 192
struct mlnx_gpio_i2c_ioctl_params dev_gpio_bus8 = {
	.element_num = 1,
	.exp = { { "gpio-i2cmux",
                    8,                      /* Parent I2C bus adapter number */
                    0,                      /* Chip Id */
                    100,                    /* Base I2C bus number */
                    16,                     /* Number of multiplexer positions (buses to instantiate) */
                    1,                      /* Number of GPIOs used to control MUX */
                    { 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1 }, /* Array of bitmasks of GPIO */
                                            /*28, 29, 40, 44, 45,*/
                    { GPIO0_BASE_NR + 27 }, /* Array of GPIO numbers used to control MUX */
	            { 1 },                  /* Array of GPIO directions for pins controlling MUX */
	            { GPIO_IN },            /* Array of GPIO initial values for pins controlling MUX */
                    ((unsigned)-1),
                } },
};
struct mlnx_gpio_i2c_del_ioctl_params dev_gpio_bus8_delete = {
	.element_num = 1,
	.parent_bus_num = { 8 },
};

struct mlnx_i2c_devices_ioctl_params dev_bus20 = {
	.element_num = 7,
	.parent_bus_num = 20,
	.dev = { { 0x40, "qsfp", 0 }, { 0x41, "qsfp", 0 }, { 0x42, "qsfp", 0 }, { 0x43, "qsfp", 0 },
		 { 0x44, "qsfp", 0 }, { 0x47, "qsfp", 0 }, { 0x48, "qsfp", 0 }  }, // "pca9516"
};

struct mlnx_i2c_devices_ioctl_params dev_bus30 = {
	.element_num = 1,
	.parent_bus_num = 30,
	.dev = { { 0x22, "dummy", 0 } },
};

struct mlnx_i2c_devices_ioctl_params dev_bus60 = {
	.element_num = 3,
	.parent_bus_num = 60,
	.dev = { { 0x49, "qsfp", 0 }, { 0x4a, "ds1621", 0 }, { 0x4c, "ds1621", 0 } },
};

struct mlnx_cpld_leds_config_ioctl_params cpld_leds_config_1024x = {
	.device_type = LPC_BUS_TYPE,
	.dev_id = CPLD_NO_DEV /* or 0xff */,
	.hwdev.lpc_params = { 0x2500, 0xff, 0 },
	.num_leds = 5,
	.cpld_leds = {
                { {led_status, "STATUS"}, 0x20, 0xf0, },
                { {led_fan1, "FAN1"}, 0x21, 0xf0, },
                { {led_fan2, "FAN2"}, 0x21, 0x0f, },
                { {led_ps1, "PS1"}, 0x22, 0xf0, },
                { {led_ps2, "PS2"}, 0x22, 0x0f, },
	},
};

struct mlnx_asic_fan_config_ioctl_params asic_fans_1024x = {
	4,
	{
		{ {asic_fan1_fan, "FAN1/FAN"}, 2, {1, 3}, 0, 60, {60, 60}, 125, 255 },
		{ {asic_fan2_fan, "FAN2/FAN"}, 2, {5, 7}, 0, 60, {60, 60}, 125, 255 },
		{ {asic_ps1_fan, "PS1/FAN"}, 1, {9} , 1, 60, {60}, 125, 255 },
		{ {asic_ps2_fan, "PS2/FAN"}, 1, {8}, 2, 60, {60}, 125, 255 },
	},
};

struct mlnx_asic_temp_sensor_config_ioctl_params asic_temp_1024x = {
	1,
	{
		{ {asic_temp1, "TEMP1"}, 0, 0, 0, 0, 80, 0, 80, 255 },
	},
};


struct mlnx_i2c_virt_bus_ioctl_params cpld_mux_tor_mgmt = {
	.element_num = 1,
	.parent_bus_num	= 1,
	.upper_switch_id = 0,
	.sw = { { 0x000025da, 0, 8, 0, 0x25da, { 10, 11, 12, 13, 14, 15, 16, 17 }, "cpld_mux_tor", "", 0xda} },
};

struct mlnx_i2c_virt_bus_ioctl_params cpld_mux_sw_board = {
	.element_num = 1,
	.parent_bus_num	= 1,
	.upper_switch_id = 0,
	.sw = { { 0x000025db, 0, 8, 0, 0x25db, { 2, 3, 4, 5, 6, 7, 8, 9 }, "cpld_mux_tor", "", 0xdb} },
};

struct mlnx_i2c_switch_ioctl_params cpld_mux_tor_mgmt_del = {
	.element_num = 1,
	.upper_switch_id = 0,
	.sw = { 0x000025da },
};

struct mlnx_i2c_switch_ioctl_params cpld_mux_sw_board_del = {
	.element_num = 1,
	.upper_switch_id = 0,
	.sw = { 0x000025db },
};

#define MAX_FNAME_LEN	128
#define MAX_BUF_LEN     2048
#define MAX_ACCESS_NUM  32
#define MAX_DELAY       1000
#define MAX_FILE_SZ     0x2000	/* 2KB - 32 Kbit or 64Kbit EEPROMs  */
#define MAX_I2CIO_SZ    0x10    /* Can be written only 16B in single cycle */

#define CHECK_PARAM(param, max_val) \
        if (param > max_val) {\
            fprintf(stderr, "param %zu > %u (max)\n", param, max_val);\
            return -1;\
        }\

#define CHECK_PARAM_INT(param, max_val) \
        if (param > max_val) {\
            fprintf(stderr, "param %u > %u (max)\n", param, max_val);\
            return -1;\
        }\


static char rw_buf[MAX_BUF_LEN];
char attr_name[48];
char pattern[128];
char dev_name[I2C_NAME_SIZE];

static int hexalpha_to_int(int c)
{
	char hexalpha[] = "aAbBcCdDeEfF";
	int i;
	int inp = 0;

	for (i = 0; inp == 0 && hexalpha[i] != '\0'; i++) {
		if(hexalpha[i] == c)
			inp = 10 + (i / 2);
	}
	return inp;
}

static unsigned int htoi(const char s[])
{
	unsigned int inp = 0;
	int i = 0;
	int valid = 1;
	int hexit;

	if(s[i] == '0') {
		++i;
		if(s[i] == 'x' || s[i] == 'X')
			++i;
	}
	while(valid && s[i] != '\0') {
		inp = inp * 16;
		if(s[i] >= '0' && s[i] <= '9') {
			inp = inp + (s[i] - '0');
		}
		else {
			hexit = hexalpha_to_int(s[i]);
			if(hexit == 0)
				valid = 0;
			else
				inp = inp + hexit;
		}
		++i;
	}
	if(!valid)
		inp = 0;
	return inp;
}

static void hex_dump(char *data, int size)
{
	int i; // index in data...
	int j; // index in line...
	char temp[8];
	char buffer[128];
	char *ascii;

	memset(buffer, 0, 128);
	printf("        +0          +4          +8          +c            0   4   8   c   \n");
	/* Hex portion of the line is 8 (the padding) + 3 * 16 = 52 chars long
	   with added another four bytes padding and place the ASCII version */
	ascii = buffer + 58;
	memset(buffer, ' ', 58 + 16);
	buffer[58 + 16] = '\n';
	buffer[58 + 17] = '\0';
	buffer[0] = '+';
	buffer[1] = '0';
	buffer[2] = '0';
	buffer[3] = '0';
	buffer[4] = '0';
	for (i = 0, j = 0; i < size; i++, j++) {
		if (j == 16) {
			printf("%s", buffer);
			memset(buffer, ' ', 58 + 16);
			snprintf(temp, 8, "+%04x", i);
			memcpy(buffer, temp, 5);
			j = 0;
		}
		snprintf(temp, 8, "%02x", 0xff & data[i]);
		memcpy(buffer + 8 + (j * 3), temp, 2);
		if ((data[i] > 31) && (data[i] < 127))
			ascii[j] = data[i];
		else
			ascii[j] = '.';
	}
	if (j != 0)
		printf("%s", buffer);
}

static int _add_dev(char *name, int bus, unsigned short addr)
{
        struct mlnx_i2c_one_device_ioctl_params params;
	int rc;

	params.parent_bus_num = bus;
	params.dev.i2c_dev_addr = addr;
	memcpy(&params.dev.i2c_dev_type, name, I2C_NAME_SIZE);
	rc = mlnx_add_one_device_to_vbus(&params);
	if (rc)
		printf("failed to add devices %s to bus %d at addr %x\n", dev_name, bus, addr);
	return rc;
}

static int _remove_dev(int bus, unsigned short addr)
{
        struct mlnx_i2c_one_device_ioctl_params params;
	int rc;

	params.parent_bus_num = bus;
	params.dev.i2c_dev_addr = addr;
	rc = mlnx_delete_one_device_from_vbus(&params);
	if (rc)
		printf("failed to delete devices from bus %d at addr %x\n", bus, addr);
	return rc;
}

static int _add_orca(void)
{
	int rc;

	rc = mlnx_add_i2c_virtual_buses(&orca_prime_switch);
        if (rc != 0) {
            rc = mlnx_delete_i2c_virtual_buses(&orca_prime_switch_delete);
            orca_prime_switch.sw[0].i2c_dev_addr = 0x76;
            orca_prime_switch_delete.sw[0] = 0x176;
	    rc = mlnx_add_i2c_virtual_buses(&orca_prime_switch);
        }
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_1) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_2) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_3) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_4) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_5) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_6) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_7) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_8) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_9) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_10) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_11) : rc;
	return rc;
}

static int _remove_orca(void)
{
	int rc;
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_11_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_10_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_9_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_8_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_7_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_6_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_5_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_4_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_3_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_2_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_1_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_prime_switch_delete);
        if (rc != 0) {
		orca_prime_switch_delete.sw[0] = 0x176;
	        rc = mlnx_delete_i2c_virtual_buses(&orca_prime_switch_delete);
        }
	return rc;
}

static int _add_orca_down(void)
{
	int rc;

	orca_prime_switch.sw[0].switch_id = 0x00000176;
	orca_prime_switch.sw[0].i2c_dev_addr = 0x76;
	orca_second_switch_1.upper_switch_id = 0x00000176;
	orca_second_switch_2.upper_switch_id = 0x00000176;
	orca_second_switch_3.upper_switch_id = 0x00000176;
	orca_second_switch_4.upper_switch_id = 0x00000176;
	orca_second_switch_5.upper_switch_id = 0x00000176;
	orca_second_switch_6.upper_switch_id = 0x00000176;
	orca_second_switch_7.upper_switch_id = 0x00000176;
	orca_second_switch_8.upper_switch_id = 0x00000176;
	orca_second_switch_9.upper_switch_id = 0x00000176;
	orca_second_switch_10.upper_switch_id = 0x00000176;
	orca_second_switch_11.upper_switch_id = 0x00000176;
	rc = mlnx_add_i2c_virtual_buses(&orca_prime_switch);
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_1) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_2) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_3) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_4) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_5) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_6) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_7) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_8) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_9) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_10) : rc;
	rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&orca_second_switch_11) : rc;
	return rc;
}

static int _remove_orca_down(void)
{
	int rc;

	orca_prime_switch_delete.upper_switch_id = 0,
	orca_prime_switch.sw[0].switch_id = 0x00000176;
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_11_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_10_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_9_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_8_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_7_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_6_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_5_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_4_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_3_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_2_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_second_switch_1_delete);
	rc = mlnx_delete_i2c_virtual_buses(&orca_prime_switch_delete);
	return rc;
}
static int _add_orca_sf(int parent_bus, int start_bus, int parent_switch)
{
    struct mlnx_i2c_virt_bus_ioctl_params tmp_orca_sf_prime_switch;
	int rc;
    int i;
    memcpy(&tmp_orca_sf_prime_switch, &orca_sf_prime_switch,
           sizeof(struct mlnx_i2c_virt_bus_ioctl_params));
    tmp_orca_sf_prime_switch.parent_bus_num	= parent_bus;
	tmp_orca_sf_prime_switch.upper_switch_id = parent_switch,
	tmp_orca_sf_prime_switch.sw[0].switch_id |= (parent_bus << 8);
    for (i = 0; i < LEGS_NUM; i++)
        tmp_orca_sf_prime_switch.sw[0].adap_id_array[i] += start_bus;

	rc = mlnx_add_i2c_virtual_buses(&tmp_orca_sf_prime_switch);
    return rc;
}

static int _remove_orca_sf(int parent_bus, int parent_switch)
{
	int rc;
        struct mlnx_i2c_switch_ioctl_params tmp_orca_sf_prime_switch_delete;
        memcpy(&tmp_orca_sf_prime_switch_delete, &orca_sf_prime_switch_delete,
               sizeof(struct mlnx_i2c_switch_ioctl_params));
	tmp_orca_sf_prime_switch_delete.element_num = 1,
	tmp_orca_sf_prime_switch_delete.upper_switch_id = parent_switch,
	tmp_orca_sf_prime_switch_delete.sw[0] = (parent_bus << 8) | 0x00000070,
	rc = mlnx_delete_i2c_virtual_buses(&tmp_orca_sf_prime_switch_delete);
        return rc;
}

static int _add(void)
{
	int rc;
	//rc = mlnx_add_devices_to_vbus(&dev_bus0);
	//rc = mlnx_add_devices_to_vbus(&dev_bus1);
	rc = mlnx_add_i2c_virtual_buses(&prime_switch);
#if defined(__i386__) || defined(__x86_64__)
    rc+= mlnx_add_i2c_virtual_buses(&second_switch);
#endif
	//rc = (rc == 0) ? mlnx_add_i2c_virtual_buses(&second_switch) : rc;
	memcpy(dev_name, "switchx", strlen("switchx") + 1);
	rc = (rc == 0) ? _add_dev(dev_name, 2, 0x48) : rc;
	return rc;
}

static int _remove(void)
{
	int rc;
        rc = _remove_dev(2, 0x48);
	//rc = mlnx_delete_i2c_virtual_buses(&second_switch_delete);
	rc = mlnx_delete_i2c_virtual_buses(&prime_switch_delete);
	return rc;
}

static int _remove_second(void)
{
	int rc;
	rc = mlnx_delete_i2c_virtual_buses(&second_switch_delete);
	return rc;
}

static int _remove_prim(void)
{
	int rc;
	rc = mlnx_delete_i2c_virtual_buses(&prime_switch_delete);
	return rc;
}

static int _add_dev_prim(void)
{
	int rc;

	rc = mlnx_add_devices_to_vbus(&dev_bus2);
	if (rc)
		printf("failed to add device to bus %d\n", dev_bus2.parent_bus_num);
	rc = mlnx_add_devices_to_vbus(&dev_bus7);
	if (rc)
		printf("failed to add device to bus %d\n", dev_bus7.parent_bus_num);
	rc = mlnx_add_devices_to_vbus(&dev_bus8);
	if (rc)
		printf("failed to add device to bus %d\n", dev_bus8.parent_bus_num);
	return rc;
}

static int _add_dev_second(void)
{
	int rc;
	rc = mlnx_add_devices_to_vbus(&dev_bus20);
	if (rc)
		printf("failed to add device to bus %d\n", dev_bus20.parent_bus_num);
	rc = mlnx_add_devices_to_vbus(&dev_bus30);
	if (rc)
		printf("failed to add device to bus %d\n", dev_bus30.parent_bus_num);
	rc = mlnx_add_devices_to_vbus(&dev_bus60);
	if (rc)
		printf("failed to add device to bus %d\n", dev_bus60.parent_bus_num);
	return rc;
}

static int _remove_dev_prim(void)
{
	int rc;
	rc = mlnx_delete_devices_from_vbus(&prime_switch_delete);
	if (rc)
		printf("failed to delete devices from bus primary bus\n");
	return rc;
}

static int _remove_dev_second(void)
{
	int rc;

	rc = mlnx_delete_devices_from_vbus(&second_switch_delete);
	if (rc)
		printf("failed to delete devices from bus secondary bus\n");
	return rc;
}

static int _read(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen)
{
	int rc;
	int i;

	rc = mlnx_i2c_read(bus, addr, offset, addr_width, rw_buf, datalen);
	if (rc >= 0) {
		for (i = 0; i < (int)datalen; i++)
			printf("%hhx ", rw_buf[i]);
		printf("\n");
	}
	return rc;
}

static int _write(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen)
{
	int rc;
	rc = mlnx_i2c_write(bus, addr, offset, addr_width, rw_buf, datalen);
	return rc;
}

static int _read_leg(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen)
{
	int rc;
	int i;

	rc = mlnx_i2c_read_smbus_legacy(bus, addr, offset, addr_width, rw_buf, datalen);
	if (rc >= 0) {
		for (i = 0; i < (int)datalen; i++)
			printf("%hhx ", rw_buf[i]);
		printf("\n");
	}
	return rc;
}

static int _write_leg(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen)
{
	int rc;
	rc = mlnx_i2c_write_smbus_legacy(bus, addr, offset, addr_width, rw_buf, datalen);
	return rc;
}

static int _eeprom_test(int bus, unsigned short addr, unsigned int offset, size_t datalen, size_t eeprom_size)
{
	int rc;
	rc = eeprom_rw(bus, (int)addr, (unsigned short)offset, (unsigned short)datalen, eeprom_size);
	return rc;
}

static int _read_vpd(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen)
{
	int rc;
	int i;

	rc = mlnx_read_vpd(bus, addr, offset, addr_width, rw_buf, datalen);
	if (rc >= 0) {
		for (i = 0; i < (int)datalen; i++) {
			printf("%hhx ", rw_buf[i]);
			if ((i > 0) && ((i % (I2C_CHUNK_MAX / 4)) == 0))
				printf("\n");
		}
		printf("\n");
	}
	return rc;
}

static int _read_write_vpd(int bus, u16 addr, u32 offset, size_t addr_width, char* data,
                           size_t datalen, int bus_prot, u16 addr_prot, u16 reg_prot,
                           u8 get_prot, u8 put_prot, int limit, int border,
                           int rchunk_del, int wchunk_del, int post_del, unsigned char flags)
{
	int rc;
	int i;
	struct mlnx_rdwr_vpd_i2c_ioctl_params params;

        if (flags == 0)
                memcpy(&params.databuf, data, datalen); /* Data buffer */
	params.bus = bus;                       /* Bus id to which read or write request is to be sent */
	params.addr = addr;                     /* VPD slave address */
	params.flags = flags;                   /* Access flag - 0 for write, 1 for read */
	params.offset = offset;                 /* Offset inside VPD, when data is to be read or written */
	params.datalen = datalen;              /* Length of data is to be read or written */
	params.addr_width = addr_width;         /* VPD internal address space */
	params.bus_prot = bus_prot;             /* Bus id, which is used for access protection */
	params.addr_prot = addr_prot;           /* Device address, which is used for access protection */
	params.reg_prot = reg_prot;             /* Device register offset, which is used for access protection */
	params.get_prot = get_prot;             /* Value be written to get protection */
	params.put_prot = put_prot;             /* Value be written to put protection */
	params.limit = limit;                   /* Access limit in msec */
	params.border = border;                 /* Border limit, which could not be crossing by one transaction */
	params.read_chunk_delay = rchunk_del;   /* Delay in msec between chunk reading */
	params.write_chunk_delay = wchunk_del;  /* Delay in msec between chunk writing */
	params.post_delay = post_del;         /* Delay in msec after protected bus release */

	rc = mlnx_vpd_rw_limited(&params);
	if ((rc >= 0) && (flags == 1)) {
		for (i = 0; i < (int)datalen; i++) {
			printf("%hhx ", params.databuf[i]);
			if ((i > 0) && ((i % (I2C_CHUNK_MAX / 4)) == 0))
				printf("\n");
		}
		printf("\n");
	}
	return rc;
}

static int _read_crspace(int bus, unsigned short addr, unsigned int offset, size_t datalen)
{
	int rc;
	int i;
	int i1;
	int len;
	char* data = rw_buf;
	int to;
	int tail;

	len = datalen;
	while (len > 0) {
		if (datalen > I2C_CHUNK_MAX)
			datalen = I2C_CHUNK_MAX;
		memset(rw_buf, 0, datalen);
		rc = mlnx_read_crspace(bus, addr, offset, rw_buf, datalen);
		if (rc >= 0) {
			to = (int)(datalen / 16);
			tail = (int)datalen - to*16;
			for (i1 = 0; i1 < to; i1++) {
				printf("0x%08x : ", offset + 16*i1);
				for (i = 0; i < 16; i++)
					printf("0x%02hhx ", rw_buf[i + 16*i1]);
				printf("\n");
			}
			if (tail) {
				printf("0x%08x : ", offset + 16*i1);
				for (i = 0; i < tail; i++)
					printf("0x%02hhx ", rw_buf[i + 16*i1]);
				printf("\n");
			}
		}
		len -= datalen;
		offset += datalen;
		data += datalen;
		datalen = len;
	}
	return rc;
}

static int _write_vpd(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen)
{
	int rc;
	rc = mlnx_write_vpd(bus, addr, offset, addr_width, rw_buf, datalen);
	return rc;
}

static int _read_num(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen, int num, int  seq, int delay)
{
	int rc;
	int i;
	int j;

	for (j= 0; j < num; j++) {
		rc = mlnx_i2c_read(bus, addr, offset, addr_width, rw_buf, datalen);
		if (delay != 0)
			usleep(delay);
		if (seq)
			offset = 0;
		else
			offset += datalen;
		if (rc >= 0) {
			for (i = 0; i < (int)datalen; i++)
				printf("%hhx ", rw_buf[i]);
			printf("\n");
		}
		else {
			printf("failed request=%d\n", j);
		}
	}
	return rc;
}

static int _write_num(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen, int num, int seq, int delay)
{
	int rc;
	int j;
	for (j= 0; j < num; j++) {
		rc = mlnx_i2c_write(bus, addr, offset, addr_width, rw_buf, datalen);
		if (seq)
			offset = 0;
		else
			offset += datalen;
		if (delay != 0)
			usleep(delay);
		if (rc < 0)
			printf("failed request=%d\n", j);
	}
	return rc;
}

static int _write_read_num(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen, int num,  int seq, int delay)
{
	int rc;
	int j;
	int write_offset = offset;
	for (j= 0; j < num; j++) {
		rc = mlnx_i2c_write(bus, addr, write_offset, addr_width, rw_buf, datalen);
		if (rc < 0)
			printf("write failed request=%d\n", j);
		if (delay != 0)
			usleep(delay);
		rc = mlnx_i2c_read(bus, addr, offset, addr_width, rw_buf, datalen);
		if (rc < 0)
			printf("read failed request=%d\n", j);
		if (seq)
			write_offset = 0;
		else
			write_offset += datalen;
	}
	return rc;
}

static int _read_write_num(int bus, unsigned short addr, unsigned int offset, size_t addr_width, size_t datalen, int num)
{
	int rc;
	int j;
	for (j= 0; j < num; j++) {
		rc = mlnx_i2c_read(bus, addr, offset, addr_width, rw_buf, datalen);
		if (rc < 0)
			printf("read failed request=%d\n", j);
		rc = mlnx_i2c_write(bus, addr, offset, addr_width, rw_buf, datalen);
		if (rc < 0)
			printf("write failed request=%d\n", j);
		offset += datalen;
	}
	return rc;
}

static int _read_attr(const char *attr, int bus, unsigned short addr, unsigned int offset, size_t datalen)
{
	int rc;

	rc = mlnx_i2c_read_attr(attr, bus, addr, offset, datalen, rw_buf);
	if (rc >= 0)
		hex_dump(rw_buf, (int)datalen);
	return rc;
}

static int _read_attr_cached(const char *attr, int bus, unsigned short addr, unsigned int offset, size_t datalen)
{
	int rc;

	rc = mlnx_i2c_read_attr_cached(attr, bus, addr, offset, datalen, rw_buf);
	if (rc >= 0)
		hex_dump(rw_buf, (int)datalen);
	return rc;
}

static int _write_attr(const char *attr, int bus, unsigned short addr, unsigned int offset, size_t datalen)
{
	int rc;
	rc = mlnx_i2c_write_attr(attr, bus, addr, offset, datalen, rw_buf);
	return rc;
}

static int _read_attr_num(const char *attr, int bus, unsigned short addr, unsigned int offset, size_t datalen, int num)
{
	int rc;
	int j;

	for (j= 0; j < num; j++) {
		rc = mlnx_i2c_read_attr(attr, bus, addr, offset, datalen, rw_buf);
		offset += datalen;
		if (rc >= 0)
			hex_dump(rw_buf, (int)datalen);
	}
	return rc;
}

static int _write_attr_num(const char *attr, int bus, unsigned short addr, unsigned int offset, size_t datalen, int num)
{
	int rc;
	int j;

	for (j= 0; j < num; j++) {
		rc = mlnx_i2c_write_attr(attr, bus, addr, offset, datalen, rw_buf);
		if (rc < 0)
			printf("write failed request=%d\n", j);
		offset += datalen;
	}

	return rc;
}

static int _scan_bus(int bus)
{
	struct mlnx_i2c_virt_bus_scan_ioctl_params params;
	int i;
	unsigned int j;
	int rc;
	memset(&params, 0, sizeof(struct mlnx_i2c_virt_bus_scan_ioctl_params));
	params.parent_bus_num = bus;
	rc = mlnx_scan_switch_devices(&params);
	printf("bus id %d:\n", params.parent_bus_num);
	for (i = 0; i < 8; i++) {
		printf("0x%08x ", params.presence[i]);
		if ((i+1)%4 == 0)
			printf("\n");
	}
	for (i = 0; i < 8; i++) {
		for (j = 0; j < 31; j++) {
			if ((params.presence[i] >> j) & 0x1)
				printf("%x\n", i + j);
		}
	}
	return rc;
}

static int _add_gpio_bus(void)
{
	struct mlnx_gpio_i2c_ioctl_params params;
	int rc;
	memset(&params, 0, sizeof(struct mlnx_gpio_i2c_ioctl_params));
	memcpy(&params, &dev_gpio_bus8, sizeof(struct mlnx_gpio_i2c_ioctl_params));
	rc = mlnx_add_gpio_i2c_buses(&params);
	return rc;
}

static int _remove_gpio_bus(void)
{
	struct mlnx_gpio_i2c_del_ioctl_params params;
	int rc;
	memset(&params, 0, sizeof(struct mlnx_gpio_i2c_del_ioctl_params));
	memcpy(&params, &dev_gpio_bus8_delete, sizeof(struct mlnx_gpio_i2c_del_ioctl_params));
	rc = mlnx_del_gpio_i2c_buses(&params);
	return rc;
}

static int _prepare_file(char* fname, char** buf, char fmode)
{
    struct stat st;
    int sz, rc;

    *buf = NULL;

	if (!fname) {
		fprintf(stderr, "filename isn't provided\n");
		return -1;
	}

    if (fmode) {
        rc = stat(fname, &st);
        if (!rc) {
            if (!st.st_size) {
                fprintf(stderr, "no data in file %s\n", fname);
                return -1;
            }
            sz = st.st_size;
        }
        else {
            fprintf(stderr, "stat of file %s error: %s\n", fname, strerror(errno));
            return -1;
        }

    }
    else
        sz = MAX_FILE_SZ;

    *buf = malloc(sz);
    if (!(*buf)) {
        fprintf(stderr, "Failed to allocate buffer: %s(%d)\n", strerror(errno), errno);
        return -1;
    }

    return sz;
}

static int _read_file_fs(char* fname, char* buf, int sz)
{
    int fd;

    fd = open(fname, O_RDONLY, 0444);
    if (fd < 0) {
        fprintf(stderr, "Failed to open file %s, %s\n", fname, strerror(errno));
        return -1;
    }
    if (read(fd, buf, sz) < 0) {
        fprintf(stderr, "Failed to read file %s, %s\n", fname, strerror(errno));
        close(fd);
        return -1;
    }
    close(fd);
    return 0;
}

static int _write_file_fs(char* fname, char* buf, int sz)
{
    int fd;

    fd = open(fname, O_WRONLY | O_CREAT | O_SYNC, 0666);
    if (fd < 0) {
        fprintf(stderr, "Failed to open file %s\n", fname);
        return -1;
    }
    if (write(fd, buf, sz) < 0) {
        fprintf(stderr, "Failed to write file %s, %s\n", fname, strerror(errno));
        close(fd);
        return -1;
    }
    close(fd);
    return 0;
}

static int _read_fru(int argc, char *argv[])
{
    int bus, rc;
    unsigned short addr, sz, offs, len = MAX_I2CIO_SZ;
    char* buf, *curr, *fname = NULL;
    size_t addr_width = 2;

    if (argc < 6) {
        fprintf(stderr, "Not all parameters are provided, %d should be 4\n", argc-2);
        return -1;
    }

    sscanf(argv[2], "%d", &bus);
	sscanf(argv[3], "%hx", &addr);
	sscanf(argv[4], "%hx", &sz);
	if (!argv[5] || (strlen(argv[5]) < 1)) {
		fprintf(stderr, "Filename should be provided\n");
        return -1;
	}
    fname = argv[5];
    if (argc == 7)
	sscanf(argv[6], "%zd", &addr_width);

	rc = _prepare_file(fname, &buf, 0);
    if (rc < 0) {
        free(buf);
        return -1;
    }
    else if (rc < sz) {
        sz = rc;
    }

    printf("Read fru %d - 0x%x, sz - %d to file %s\n", bus, addr, sz, fname);
    curr = buf;
    for (offs = 0; offs < sz;) {
        rc = mlnx_i2c_read(bus, addr, offs, addr_width, curr, len);
    	if (rc < 0) {
    	    if (!offs) {
                fprintf(stderr, "EEPROM %d - 0x%x was not read.\n", bus, addr);
                free(buf);
                return -1;
            }
            else
                break;
    	}
        else {
            offs += len;
            curr = buf + offs;
			if ((offs + MAX_I2CIO_SZ) > sz)
                len = sz - offs;
        }
    }

    rc = _write_file_fs(fname, buf, sz);
    free(buf);
    return rc;
}

static int _write_fru(int argc, char *argv[])
{
    int bus, rc, i = 0;
	unsigned short addr, len;
	size_t offs,sz;
    char* buf, *curr, *fname = NULL;
    size_t addr_width = 2;

    if (argc < 5) {
        fprintf(stderr, "Not all parameters are provided, %d should be 3\n", argc-2);
        return -1;
    }
    if (argc == 7)
	sscanf(argv[6], "%zd", &addr_width);

    sscanf(argv[2], "%d", &bus);
	sscanf(argv[3], "%hx", &addr);
	sscanf(argv[4], "%zx", &sz);
    CHECK_PARAM(sz, MAX_FILE_SZ);
	if (!argv[5] || (strlen(argv[5]) < 1)) {
		fprintf(stderr, "Filename should be provided\n");
        return -1;
	}
    fname = argv[5];

    rc = _prepare_file(fname, &buf, 1);
    if (rc <= 0) {
        if (buf)
            free(buf);
        return -1;
    }
//    else if (rc > sz)
//		sz = rc;

    if (_read_file_fs(fname, buf, sz)) {
        if (buf)
            free(buf);
        return -1;
    }

    curr = buf;
    if (sz < MAX_I2CIO_SZ)
        len = sz;
    else
        len = MAX_I2CIO_SZ;

    for (offs = 0; offs < sz;i++) {
        rc = mlnx_i2c_write(bus, addr, offs, addr_width, curr, len);
    	if (rc < 0) {
    		if (!offs) {
                fprintf(stderr, "EEPROM %d-0x%x was not written.", bus, addr);
                free(buf);
                return -1;
            }
            else
                break;
    	}
        else {
			offs += len;
            curr = buf + offs;
			if ((offs + MAX_I2CIO_SZ) > sz)
                len = sz - offs;
            usleep(10000);
        }
    }
    //printf("Number of write operations: %d\n", i);

    free(buf);
    return 0;
}

#define I2C_SMBUS_EMUL	0x0820	/* SMBus transfer I2C emulation */
struct i2c_smbus_emul_ioctl {
	__u32 offset;                   /* offset within device address space */
	__u16 addr;	                /* slave address */
	__u8 addr_width;		/* device address space width (1,2,4) */
	__u8 read_write;                /* i2c_smbus_xfer read or write markers:
					   I2C_SMBUS_READ	1
					   I2C_SMBUS_WRITE	0 */
	__u16 len;                      /* data buffer length */
	__u8 __user *data;              /* pointers to data buffer */
};

static int block_write(int file, int addr_width, int offset, unsigned char *buf, int datalen)
{
    struct i2c_smbus_emul_ioctl msg_rw;
    msg_rw.offset = offset;
    msg_rw.len = datalen;
    msg_rw.addr_width = addr_width;
    msg_rw.read_write = I2C_SMBUS_WRITE;
    msg_rw.data = buf;
    if (datalen > 2048) {
       fprintf(stderr,  "Error: Block length too large - truncated to 2048:\n");
       datalen = 2048;
    }
    if (ioctl(file, I2C_SMBUS_EMUL, &msg_rw) < 0) {
        fprintf(stderr, "Error: Transaction failed: %s\n", strerror(errno));
        return 1;
    }
    return 0;
}

static int block_read(int file, int addr_width, int offset, unsigned char *buf, int datalen)
{
    struct i2c_smbus_emul_ioctl msg_rw;
    int i;
    int i1;
    int len = datalen;
    int len1 = datalen;
    int to;
    int tail;
    char *data = rw_buf;

    msg_rw.offset = offset;
    msg_rw.len = datalen;
    msg_rw.addr_width = addr_width;
    msg_rw.read_write = I2C_SMBUS_READ;
    msg_rw.data = buf;
    if (datalen > 2048) {
       fprintf(stderr,  "Error: Block length too large - truncated to 2048:\n");
       len = len1 = datalen = 2048;
    }
    if ((len1 = ioctl(file, I2C_SMBUS_EMUL, &msg_rw)) < 0) {
        fprintf(stderr, "Error: Read error:%d\n", len1);
        return -1;
    }
    while (len > 0) {
        if (datalen > I2C_CHUNK_MAX)
                datalen = I2C_CHUNK_MAX;
        to = (int)(datalen / 16);
        tail = (int)datalen - to*16;
        for (i1 = 0; i1 < to; i1++) {
            printf("0x%08x : ", offset + 16*i1);
            for (i = 0; i < 16; i++)
                printf("0x%02hhx ", rw_buf[i + 16*i1]);
	    printf("\n");
        }
	if (tail) {
            printf("0x%08x : ", offset + 16*i1);
            for (i = 0; i < tail; i++)
               printf("0x%02hhx ", rw_buf[i + 16*i1]);
            printf("\n");
        }
	len -= datalen;
	offset += datalen;
	data += datalen;
	datalen = len;
    }
    return len1;
}

static int _emul4_write(char *fname, int offset, int datalen)
{
    int fd;
    int rc;

	if (!fname) {
		fprintf(stderr, "filename isn't provided\n");
		return -1;
	}

    fd = open(fname, O_WRONLY | O_CREAT | O_SYNC, 0666);
    if (fd < 0) {
        fprintf(stderr, "Failed to open file %s\n", fname);
        return -1;
    }
    rc = block_write(fd, 4, offset, (unsigned char *)rw_buf, datalen);
    close(fd);
    return rc;
}

static int _emul4_read (char* fname, int offset, int datalen)
{
    int fd;
    int rc;

	if (!fname) {
		fprintf(stderr, "filename isn't provided\n");
		return -1;
	}

    fd = open(fname, O_RDONLY, 0444);
    if (fd < 0) {
        fprintf(stderr, "Failed to open file %s, %s\n", fname, strerror(errno));
        return -1;
    }
    rc = block_read(fd, 4, offset, (unsigned char *)rw_buf, datalen);
    close(fd);
    return rc;
}

#define I2C_M_WR_EM		0x0002	/* read data, from slave to master - i2c emulation dword addr space */
#define I2C_M_RD_EM		0x0003	/* read data, from slave to master - i2c emulation word addr space */
#define I2C_M_WR_EM_2		0x0004	/* read data, from slave to master - i2c emulation */
#define I2C_M_RD_EM_2		0x0005	/* read data, from slave to master - i2c emulation */
static void translate_offset_addr(u32 addr, u32 offset, u32 len, u8 width, unsigned char *addr_buf,
				  struct i2c_msg *msg, u8 *in_out_buf, u8 flag)
{
	unsigned char *msg0;
	struct i2c_msg *msg_i2c = msg;

//offset = __be32_to_cpu(*((u_int32_t *)&offset));
	if ((flag == I2C_M_RD) || (flag == I2C_M_RD_EM) || (flag == I2C_M_RD_EM_2)) {
		msg0 = addr_buf;
		switch (width) {
			case 4:
				*msg0++ = /*offset;*/offset >> 24;
				*msg0++ = /*offset >> 8;*/offset >> 16;
				*msg0++ = /*offset >> 16;*/offset >> 8;
				*msg0 = /*offset >> 24;*/offset;
				break;
			case 2:
				offset &= 0xffff;
				*msg0++ = offset >> 8;
				*msg0 = offset;
				break;
			case 1:
				offset &= 0xff;
				*msg0 = offset;
				break;
		}
		msg_i2c->addr = addr;
		msg_i2c->flags = flag;
		msg_i2c->buf = addr_buf;
		msg_i2c->len = width;
		msg_i2c++;
		msg_i2c->addr = addr;
		msg_i2c->flags = flag;
		msg_i2c->buf = in_out_buf;
		msg_i2c->len = len;
	}
	else {
		msg0 = in_out_buf;
		switch (width) {
			case 4:
				*msg0++ = offset >> 24;
				*msg0++ = offset >> 16;
				*msg0++ = offset >> 8;
				*msg0 = offset;
				break;
			case 2:
				offset &= 0xffff;
				*msg0++ = offset >> 8;
				*msg0 = offset;
				break;
			case 1:
				offset &= 0xff;
				*msg0 = offset;
				break;
		}
		msg_i2c->addr = addr;
		msg_i2c->flags = flag;
		msg_i2c->len = width + len;
		msg_i2c->buf = in_out_buf;
	}
}

static int block_write_i2c_rdrw(int file, int addr_width, int offset, unsigned char *buf,
                                int datalen, unsigned short addr)
{
    struct i2c_rdwr_ioctl_data msg_rw;
    struct i2c_msg i2msgs[2]; // Need only 1 element, 2 - for conistsency
    struct i2c_msg *p_i2msgs = i2msgs;

    if (datalen > 2048) {
       fprintf(stderr,  "Error: Block length too large - truncated to 2048:\n");
       datalen = 2048;
    }
    translate_offset_addr(addr, offset, datalen, addr_width, NULL,
		          p_i2msgs, buf, I2C_M_WR_EM);
    msg_rw.msgs = i2msgs;
    msg_rw.nmsgs = 1;
    if (ioctl(file, I2C_RDWR, &msg_rw) < 0) {
        fprintf(stderr, "Error: Transaction failed: %s\n", strerror(errno));
        return 1;
    }
    return 0;
}

static int block_read_i2c_rdrw(int file, int addr_width, int offset, unsigned char *buf,
                               int datalen, unsigned short addr)
{
    struct i2c_rdwr_ioctl_data msg_rw;
    struct i2c_msg i2msgs[2];
    struct i2c_msg *p_i2msgs = i2msgs;
    unsigned char addr_buf[4];
    int i;
    int i1;
    int len = datalen;
    int len1 = datalen;
    int to;
    int tail;
    char *data = rw_buf;

    if (datalen > 2048) {
       fprintf(stderr,  "Error: Block length too large - truncated to 2048:\n");
       len = len1 = datalen = 2048;
    }
    translate_offset_addr(addr, offset, datalen, addr_width, addr_buf,
		          p_i2msgs, buf, I2C_M_RD_EM);
    msg_rw.msgs = i2msgs;
    msg_rw.nmsgs = 2;

    if ((len1 = ioctl(file, I2C_RDWR, &msg_rw)) < 0) {
        fprintf(stderr, "Error: Read error:%d\n", len1);
        return -1;
    }
    while (len > 0) {
        if (datalen > I2C_CHUNK_MAX)
                datalen = I2C_CHUNK_MAX;
        to = (int)(datalen / 16);
        tail = (int)datalen - to*16;
        for (i1 = 0; i1 < to; i1++) {
            printf("0x%08x : ", offset + 16*i1);
            for (i = 0; i < 16; i++)
                printf("0x%02hhx ", rw_buf[i + 16*i1]);
	    printf("\n");
        }
	if (tail) {
            printf("0x%08x : ", offset + 16*i1);
            for (i = 0; i < tail; i++)
               printf("0x%02hhx ", rw_buf[i + 16*i1]);
            printf("\n");
        }
	len -= datalen;
	offset += datalen;
	data += datalen;
	datalen = len;
    }
    return len1;
}

static int _emul_write(char *fname, int offset, int datalen, unsigned short addr)
{
    int fd;
    int rc;

	if (!fname) {
		fprintf(stderr, "filename isn't provided\n");
		return -1;
	}

    fd = open(fname, O_WRONLY | O_CREAT | O_SYNC, 0666);
    if (fd < 0) {
        fprintf(stderr, "Failed to open file %s\n", fname);
        return -1;
    }
    rc = block_write_i2c_rdrw(fd, 4, offset, (unsigned char *)rw_buf, datalen, addr);
    close(fd);
    return rc;
}

static int _emul_read (char* fname, int offset, int datalen, unsigned short addr)
{
    int fd;
    int rc;

	if (!fname) {
		fprintf(stderr, "filename isn't provided\n");
		return -1;
	}

    fd = open(fname, O_RDONLY, 0444);
    if (fd < 0) {
        fprintf(stderr, "Failed to open file %s, %s\n", fname, strerror(errno));
        return -1;
    }
    rc = block_read_i2c_rdrw(fd, 4, offset, (unsigned char *)rw_buf, datalen, addr);
    close(fd);
    return rc;
}

static int _config_led_1024x(void)
{
	int rc;

	rc = mlnx_cpld_leds_config(&cpld_leds_config_1024x);
	if (rc)
		printf("failed to configure leds\n");
	return rc;
}

static int _config_fan_1024x(void)
{
	int rc;

	rc = mlnx_asic_fan_config(&asic_fans_1024x);
	if (rc)
		printf("failed to configure fans\n");
	return rc;
}

static int _config_temp_sensor_1024x(void)
{
	int rc;

	rc = mlnx_asic_temp_config(&asic_temp_1024x);
	if (rc)
		printf("failed to configure temperatue sensors\n");
	return rc;
}

static int _add_cpld_mux(void)
{
	int rc;

	rc = mlnx_add_i2c_virtual_buses(&cpld_mux_sw_board);
	rc += mlnx_add_i2c_virtual_buses(&cpld_mux_tor_mgmt);

    return rc;
}

static int _remove_cpld_mux(void)
{
	int rc;
	rc = mlnx_delete_i2c_virtual_buses(&cpld_mux_tor_mgmt_del);
	rc = mlnx_delete_i2c_virtual_buses(&cpld_mux_sw_board_del);

	return rc;
}

static void usage(char *argv[])
{
	printf( "%s _read [bus][addr][offset][width][len]\n",argv[0]);
	printf( "%s _write [bus][addr][offset][width][len][data]\n",argv[0]);
	printf( "%s _read_num [bus][addr][offset][width][len][num]\n",argv[0]);
	printf( "%s _write_num [bus][addr][offset][width][len][num][seq][delay][data]\n",argv[0]);
	printf( "%s _write_read_num [bus][addr][offset][width][len][num][seq][delay][data]\n",argv[0]);
	printf( "%s _read_write_num [bus][addr][offset][width][len][num][seq][delay][data]\n",argv[0]);
	printf( "%s _read_attr [attr][bus][addr][offset][len]\n",argv[0]);
	printf( "%s _read_attr_cached [attr][bus][addr][offset][len][in-len][optional in-data]\n",argv[0]);
	printf( "%s _write_attr [attr][bus][addr][offset][len][data]\n",argv[0]);
	printf( "%s _read_attr_num [attr][bus][addr][offset][len][num]\n",argv[0]);
	printf( "%s _write_attr_num [attr][bus][addr][offset][len][num][data]\n",argv[0]);
	printf( "%s _add\n",argv[0]);
	printf( "%s _remove_orca\n",argv[0]);
	printf( "%s _add_orca\n",argv[0]);
	printf( "%s _remove_orca_down\n",argv[0]);
	printf( "%s _add_orca_down\n",argv[0]);
	printf( "%s _add_orca_sf [parent bus][start bus][parent switch hex]\n",argv[0]);
	printf( "%s _remove_orca_sf [parent bus][parent switch hex]\n",argv[0]);
	printf( "%s _remove\n",argv[0]);
	printf( "%s _remove_second\n",argv[0]);
	printf( "%s _remove_prim\n",argv[0]);
	printf( "%s _add_dev_prim\n",argv[0]);
	printf( "%s _add_dev_second\n",argv[0]);
	printf( "%s _remove_dev_prim\n",argv[0]);
	printf( "%s _remove_dev_second\n",argv[0]);
	printf( "%s _add_dev [name][bus][addr]\n",argv[0]);
	printf( "%s _remove_dev [bus][addr]\n",argv[0]);
	printf( "%s _scan_bus [bus]\n",argv[0]);
	printf( "%s _add_gpio_bus\n",argv[0]);
	printf( "%s _remove_gpio_bus\n",argv[0]);
        printf( "%s _write_fru [bus][addr][fname][opt:width]\n",argv[0]);
        printf( "%s _read_fru [bus][addr][fname][opt:width]\n",argv[0]);
	printf( "%s _read_vpd [bus][addr][offset][width][len]\n",argv[0]);
	printf( "%s _write_vpd [bus][addr][offset][width][len][data]\n",argv[0]);
	printf( "%s _read_crspace [bus][addr][offset][len]\n",argv[0]);
	printf( "%s _read_leg [bus][addr][offset][width][len]\n",argv[0]);
	printf( "%s _write_leg [bus][addr][offset][width][len][data]\n",argv[0]);
	printf( "%s _eeprom_test [bus][addr][offset][datalen][size]\n",argv[0]);
	printf( "%s _emul4_read [dev name][offset][datalen]\n",argv[0]);
	printf( "%s _emul4_write [dev name][offset][datalen]\n",argv[0]);
	printf( "%s _emul_read [dev name][offset][addr][datalen]\n",argv[0]);
	printf( "%s _emul_write [dev name][offset][addr][datalen]\n",argv[0]);
	printf( "%s _read_vpd_lim [bus][addr][offset][width][bus_prot]\n",argv[0]);
	printf( "                 [addr_prot][reg_prot][get_prot][put_prot][limit][border]\n");
	printf( "                 [rchunk_del][wchunk_del][post_del][flags][len]\n");
	printf( "%s _write_vpd_lim [bus][addr][offset][width][bus_prot]\n",argv[0]);
	printf( "                  [addr_prot][reg_prot][get_prot][put_prot][limit][border]\n");
	printf( "                  [rchunk_del][wchunk_del][post_del][flags][len][data]\n");
	printf( "%s _config_led_1024x\n",argv[0]);
	printf( "%s _config_fan_1024x\n",argv[0]);
	printf( "%s _config_temp_sensor_1024x\n",argv[0]);
    printf( "%s _add_cpld_mux\n",argv[0]);
	printf( "%s _remove_cpld_mux\n",argv[0]);
	return;
}

int main(int argc, char *argv[])
{
	int bus;
        int start_bus;
        int parent_switch;
	unsigned short addr;
	unsigned int offset;
	size_t addr_width;
	size_t datalen;
	size_t inputlen;
	size_t eeprom_size;
	int rc = 0;
	char *endp = NULL;
	unsigned int rc1;
	unsigned int test;
	unsigned int num;
	int seq;
	unsigned int delay;
	size_t i;
    char *fname = NULL;

	if (argc > 1) {
		if (strcmp(argv[1], "_read") == 0) {
			if(argc != 7) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _read(bus, addr, offset, addr_width, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_write") == 0) {
			if(argc == 7) {
				sscanf(argv[2], "%d", &bus);
				sscanf(argv[3], "%hx", &addr);
				sscanf(argv[4], "%x", &offset);
				sscanf(argv[5], "%zd", &addr_width);
				sscanf(argv[6], "%zu", &datalen);
				CHECK_PARAM(datalen, I2C_BLOCK_MAX);
				if (datalen != 0) {
					usage(argv);
					return(0);
				}
				rc = _write(bus, addr, offset, addr_width, datalen);
				return(rc);
                        }
			if(argc < 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 7) {
				printf("_write: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[7 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write(bus, addr, offset, addr_width, datalen);
			else
				printf("_write: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_read_num") == 0) {
			if(argc != 10) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%u", &num);
            CHECK_PARAM_INT(num, MAX_ACCESS_NUM);
			sscanf(argv[8], "%d", &seq);
			sscanf(argv[9], "%u", &delay);
            CHECK_PARAM_INT(delay, MAX_DELAY);
			rc = _read_num(bus, addr, offset, addr_width, datalen, num, seq, delay);
			return(rc);
		}
		if (strcmp(argv[1], "_write_num") == 0) {
			if(argc < 10) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%d", &num);
            CHECK_PARAM_INT(num, MAX_ACCESS_NUM);
			sscanf(argv[8], "%d", &seq);
			sscanf(argv[9], "%u", &delay);
            CHECK_PARAM_INT(delay, MAX_DELAY);
			if ((argc - datalen) != 10) {
				printf("_write_num: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[10 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write_num: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write_num(bus, addr, offset, addr_width, datalen, num, seq, delay);
			else
				printf("_write_num: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_write_read_num") == 0) {
			if(argc < 10) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%d", &num);
            CHECK_PARAM_INT(num, MAX_ACCESS_NUM);
			sscanf(argv[8], "%d", &seq);
			sscanf(argv[9], "%u", &delay);
            CHECK_PARAM_INT(delay, MAX_DELAY);
			if ((argc - datalen) != 10) {
				printf("_write_read_num: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[10 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write_read_num: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write_read_num(bus, addr, offset, addr_width, datalen, num, seq, delay);
			else
				printf("_write_read_num: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_read_write_num") == 0) {
			if(argc < 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%d", &num);
            CHECK_PARAM_INT(num, MAX_ACCESS_NUM);
			if ((argc - datalen) != 8) {
				printf("_read_write_num: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[8 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_read_write_num: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _read_write_num(bus, addr, offset, addr_width, datalen, num);
			else
				printf("_read_write_num: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_read_attr") == 0) {
			if(argc != 7) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%s", attr_name);
			sscanf(argv[3], "%d", &bus);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%x", &offset);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _read_attr(attr_name, bus, addr, offset, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_read_attr_cached") == 0) {
			if(argc < 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%s", attr_name);
			sscanf(argv[3], "%d", &bus);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%x", &offset);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%zd", &inputlen);
            CHECK_PARAM(inputlen, I2C_BLOCK_MAX);
			if ((argc - inputlen) != 8) {
				printf("_read_attr_cached: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			if(inputlen == 0) {
				rc = _read_attr(attr_name, bus, addr, offset, datalen);
				return(rc);
			}
			memset(rw_buf, 0, (int)datalen);
			for (i = 0; i < inputlen; i++) {
				rc = sscanf(argv[8 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < inputlen) {
				printf("_read_attr_cached: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _read_attr_cached(attr_name, bus, addr, offset, datalen);
			else
				printf("_read_attr_cached: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_write_attr") == 0) {
			if(argc < 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%s", attr_name);
			sscanf(argv[3], "%d", &bus);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%x", &offset);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 7) {
				printf("_write_attr: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			memset(rw_buf, 0, (int)datalen);
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[7 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write_attr: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write_attr(attr_name, bus, addr, offset, datalen);
			else
				printf("_write_attr: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_read_attr_num") == 0) {
			if(argc != 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%s", attr_name);
			sscanf(argv[3], "%d", &bus);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%x", &offset);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%d", &num);
            CHECK_PARAM_INT(num, MAX_ACCESS_NUM);
			rc = _read_attr_num(attr_name, bus, addr, offset, datalen, num);
			return(rc);
		}
		if (strcmp(argv[1], "_write_attr_num") == 0) {
			if(argc < 9) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%s", attr_name);
			sscanf(argv[3], "%d", &bus);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%x", &offset);
			sscanf(argv[6], "%zu", &datalen);
            CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[7], "%d", &num);
            CHECK_PARAM_INT(num, MAX_ACCESS_NUM);
			if ((argc - datalen) != 8) {
				printf("_write_attr_num: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[8 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write_attr_num: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write_attr_num(attr_name, bus, addr, offset, datalen, num);
			else
				printf("_write_attr_num: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_add") == 0) {

			rc = _add();
			return(rc);
		}
		if (strcmp(argv[1], "_remove") == 0) {

			rc = _remove();
			return(rc);
		}
		if (strcmp(argv[1], "_add_orca") == 0) {

			rc = _add_orca();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_orca") == 0) {

			rc = _remove_orca();
			return(rc);
		}
		if (strcmp(argv[1], "_add_orca_down") == 0) {

			rc = _add_orca_down();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_orca_down") == 0) {

			rc = _remove_orca_down();
			return(rc);
		}
		if (strcmp(argv[1], "_add_orca_sf") == 0) {

			if(argc != 5) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%d", &start_bus);
			sscanf(argv[4], "%x", &parent_switch);
			rc = _add_orca_sf(bus, start_bus, parent_switch);
			return(rc);
		}
		if (strcmp(argv[1], "_remove_orca_sf") == 0) {

			if(argc != 4) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%x", &parent_switch);
			rc = _remove_orca_sf(bus, parent_switch);
			return(rc);
		}
		if (strcmp(argv[1], "_remove_second") == 0) {

			rc = _remove_second();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_prim") == 0) {

			rc = _remove_prim();
			return(rc);
		}
		if (strcmp(argv[1], "_add_dev_prim") == 0) {

			rc = _add_dev_prim();
			return(rc);
		}
		if (strcmp(argv[1], "_add_dev_second") == 0) {

			rc = _add_dev_second();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_dev_prim") == 0) {

			rc = _remove_dev_prim();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_dev_second") == 0) {

			rc = _remove_dev_second();
			return(rc);
		}
		if (strcmp(argv[1], "_add_dev") == 0) {

			if(argc != 5) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%s", dev_name);
			sscanf(argv[3], "%d", &bus);
			sscanf(argv[4], "%hx", &addr);
			rc = _add_dev(dev_name, bus, addr);
			return(rc);
		}
		if (strcmp(argv[1], "_remove_dev") == 0) {

			if(argc != 4) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			rc = _remove_dev(bus, addr);
			return(rc);
		}
		if (strcmp(argv[1], "_scan_bus") == 0) {
			if(argc != 3) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			rc = _scan_bus(bus);
			return(rc);
		}
		if (strcmp(argv[1], "_add_gpio_bus") == 0) {
			if(argc != 2) {
				usage(argv);
				return(0);
			}
			rc = _add_gpio_bus();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_gpio_bus") == 0) {
			if(argc != 2) {
				usage(argv);
				return(0);
			}
			rc = _remove_gpio_bus();
			return(rc);
		}
		if (strcmp(argv[1], "_write_fru") == 0) {
			if(argc < 5) {
				usage(argv);
				return(0);
			}
			rc = _write_fru(argc, argv);
			return(rc);
		}
		if (strcmp(argv[1], "_read_fru") == 0) {
			if(argc < 5) {
				usage(argv);
				return(0);
			}
			rc = _read_fru(argc, argv);
			return(rc);
		}

		if (strcmp(argv[1], "_read_vpd") == 0) {
			if(argc != 7) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _read_vpd(bus, addr, offset, addr_width, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_write_vpd") == 0) {
			if(argc < 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 7) {
				printf("_write: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[7 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write_vpd(bus, addr, offset, addr_width, datalen);
			else
				printf("_write_vpd: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_read_crspace") == 0) {
			if(argc != 6) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _read_crspace(bus, addr, offset, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_read_vpd_lim") == 0) {
			int bus_prot, rchunk_del, wchunk_del, limit, border, post_del;
			u16 addr_prot, reg_prot;
                        u8 get_prot, put_prot;
                        u8 flags;
			if(argc != 18) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%d", &bus_prot);
			sscanf(argv[7], "%hx", &addr_prot);
			sscanf(argv[8], "%hx", &reg_prot);
			sscanf(argv[9], "%hhx", &get_prot);
			sscanf(argv[10], "%hhx", &put_prot);
			sscanf(argv[11], "%d", &limit);
			sscanf(argv[12], "%d", &border);
			sscanf(argv[13], "%d", &rchunk_del);
			sscanf(argv[14], "%d", &wchunk_del);
			sscanf(argv[15], "%d", &post_del);
			sscanf(argv[16], "%hhx", &flags);
			sscanf(argv[17], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);

			rc = _read_write_vpd(bus, addr, offset, addr_width, rw_buf,
                                             datalen, bus_prot, addr_prot, reg_prot,
                                             get_prot, put_prot, limit, border,
                                             rchunk_del, wchunk_del, post_del, flags);
			return(rc);
		}
		if (strcmp(argv[1], "_write_vpd_lim") == 0) {
			int bus_prot, rchunk_del, wchunk_del, post_del, limit, border;
			u16 addr_prot, reg_prot;
                        u8 get_prot, put_prot;
                        unsigned char flags;
			if(argc < 19) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%d", &bus_prot);
			sscanf(argv[7], "%hx", &addr_prot);
			sscanf(argv[8], "%hx", &reg_prot);
			sscanf(argv[9], "%hhx", &get_prot);
			sscanf(argv[10], "%hhx", &put_prot);
			sscanf(argv[11], "%d", &limit);
			sscanf(argv[12], "%d", &border);
			sscanf(argv[13], "%d", &rchunk_del);
			sscanf(argv[14], "%d", &wchunk_del);
			sscanf(argv[15], "%d", &post_del);
			sscanf(argv[16], "%hhx", &flags);
			sscanf(argv[17], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 18) {
				printf("_write: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[18 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _read_write_vpd(bus, addr, offset, addr_width, rw_buf,
					datalen, bus_prot, addr_prot, reg_prot,
					get_prot, put_prot, limit, border,
					rchunk_del, wchunk_del, post_del, flags);
			else
				printf("_write_vpd: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_read_leg") == 0) {
			if(argc != 7) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _read_leg(bus, addr, offset, addr_width, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_write_leg") == 0) {
			if(argc < 8) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zd", &addr_width);
			sscanf(argv[6], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 7) {
				printf("_write: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[7 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc1 = htoi(rw_buf);
			test = (unsigned int)strtoul(rw_buf, &endp, 16);
			if((*endp != '\0' && rc == 0) || rc1 == test)
				rc = _write_leg(bus, addr, offset, addr_width, datalen);
			else
				printf("_write: bad input %s (%u)\n", rw_buf, rc1);
			return(rc);
		}
		if (strcmp(argv[1], "_eeprom_test") == 0) {
			if(argc != 7) {
				usage(argv);
				return(0);
			}
			sscanf(argv[2], "%d", &bus);
			sscanf(argv[3], "%hx", &addr);
			sscanf(argv[4], "%x", &offset);
			sscanf(argv[5], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			sscanf(argv[6], "%zd", &eeprom_size);
			rc = _eeprom_test(bus, addr, offset, datalen, eeprom_size);
			return(rc);
		}
		if (strcmp(argv[1], "_emul4_read") == 0) {
			if(argc != 5) {
				usage(argv);
				return(0);
			}
			if (!argv[2] || (strlen(argv[2]) < 1)) {
				fprintf(stderr, "Filename should be provided\n");
				return -1;
			}
			fname = argv[2];
			sscanf(argv[3], "%x", &offset);
			sscanf(argv[4], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _emul4_read(fname, offset, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_emul4_write") == 0) {
			if(argc != 5) {
				usage(argv);
				return(0);
			}
			if (!argv[2] || (strlen(argv[2]) < 1)) {
				fprintf(stderr, "Filename should be provided\n");
				return -1;
			}
			fname = argv[2];
			sscanf(argv[3], "%x", &offset);
			sscanf(argv[4], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 5) {
				printf("_write: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[5 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc = _emul4_write(fname, offset, datalen);
			return(rc);
		}
		if (strcmp(argv[1], "_emul_read") == 0) {
			if(argc != 6) {
				usage(argv);
				return(0);
			}
			if (!argv[2] || (strlen(argv[2]) < 1)) {
				fprintf(stderr, "Filename should be provided\n");
				return -1;
			}
			fname = argv[2];
			sscanf(argv[3], "%x", &offset);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			rc = _emul_read(fname, offset, datalen, addr);
			return(rc);
		}
		if (strcmp(argv[1], "_emul_write") == 0) {
			if(argc != 6) {
				usage(argv);
				return(0);
			}
			if (!argv[2] || (strlen(argv[2]) < 1)) {
				fprintf(stderr, "Filename should be provided\n");
				return -1;
			}
			fname = argv[2];
			sscanf(argv[3], "%x", &offset);
			sscanf(argv[4], "%hx", &addr);
			sscanf(argv[5], "%zu", &datalen);
                        CHECK_PARAM(datalen, I2C_BLOCK_MAX);
			if ((argc - datalen) != 6) {
				printf("_write: bad input argc=%u datalen=%zu\n", argc, datalen);
				return(0);
			}
			for (i = 0; i < datalen; i++) {
				rc = sscanf(argv[6 + i], "%hhx", &rw_buf[i]);
				if (rc != 1)
					break;
			}
			if (i < datalen) {
				printf("_write: bad data len %s i=%zd len=%zd (%d)\n", rw_buf, i, datalen, rc);
				return(0);
			}
			rc = _emul_write(fname, offset, datalen, addr);
			return(rc);
		}
		if (strcmp(argv[1], "_config_led_1024x") == 0) {
			if(argc != 2) {
				usage(argv);
				return(0);
			}
			rc = _config_led_1024x();
			return(rc);
		}
		if (strcmp(argv[1], "_config_fan_1024x") == 0) {
			if(argc != 2) {
				usage(argv);
				return(0);
			}
			rc = _config_fan_1024x();
			return(rc);
		}
		if (strcmp(argv[1], "_config_temp_sensor_1024x") == 0) {
			if(argc != 2) {
				usage(argv);
				return(0);
			}
			rc = _config_temp_sensor_1024x();
			return(rc);
		}
        if (strcmp(argv[1], "_add_cpld_mux") == 0) {

			rc = _add_cpld_mux();
			return(rc);
		}
		if (strcmp(argv[1], "_remove_cpld_mux") == 0) {

			rc = _remove_cpld_mux();
			return(rc);
		}
		if (strcmp(argv[1], "?") == 0) {
			usage(argv);
			return(0);
		}
	}
	usage(argv);
	return 0;
}




